<script setup>
import {ref,reactive, onMounted} from "vue";

import { useThemeStore} from "../../stores/theme";
import AppimmoService from "../../services/appimmo.service";
import { useToastStore } from "../../stores/toast";

import Toast from './Toast.vue'

const toastStore = useToastStore()
const appimmoService = AppimmoService
const themeStore = useThemeStore()


const users = ref([])
const roles = ref([])

const currentUser = ref({
  id: null,
  name: null
})


const modalOpened = ref(false)
const modalTitle = ref(null)


const success = ref(true)
const responseMsg = ref("")
const errorMsg = ref("")
const msgType = ref("")
const msgUsers = ref("")

const isShowing = ref(false)
const isEditing = ref(false)
const isCreating = ref(false)


const closeModal = () => {
  currentUser.value.name = null
  currentUser.value.id = null
  getUsers()

  modalOpened.value = false
  isEditing.value = false
  isShowing.value = false
  errorMsg.value = ""
  success.value = true
}

const openModal = () => {
  modalOpened.value = true
}


const create = () => {
  isEditing.value = false
  isShowing.value = false
  isCreating.value = true

  modalTitle.value = "Ajouter un utilisateur"
  openModal()
}

const edit = (user_id) => {
  isEditing.value = true
  isShowing.value = false

  const user = users.value.find((users) => user_id === users.id)
  currentUser.value.name = user.username
  currentUser.value.id = user.id
  currentUser.value.role = user.role

  modalTitle.value = "Modifier un utilisateur"
  openModal()
}

const show = (index) => {
  isShowing.value = true
  isEditing.value = false
  isCreating.value = false

  currentUser.value = users.value[index]
  modalTitle.value = "Utilisateur"
  openModal()
}

const store = async () => {
  success.value = false
  responseMsg.value = ""
  msgUsers.value = ""

  const response = ref(await appimmoService.store(currentUser.value, 'register'))

  if (response.value.data.success === false) {
    errorMsg.value = ref(response.value.data.name[0])
    responseMsg.value = ref(response.value.data.message)
    success.value = false
    msgType.value = 'error'
  } else {
    responseMsg.value = ref(response.value.data.message)
    success.value = true
    msgType.value = 'success'

    getUsers()
    isCreating.value = false
    isEditing.value = true
    closeModal()
  }

  const toast = {message: ref(response.message), msgType: msgType.value, time: Date.now(), show: true}
  toastStore.newToast(toast)
}

const update = async () => {
  const response = ref(await appimmoService.update(currentUser.value, 'users/' + currentUser.value.id))
  if (response.success === false) {
    errorMsg.value = ref(response.data.name[0])
    responseMsg.value = ref(response.message)
    success.value = false
    msgUsers.value = 'error'
  } else {
    responseMsg.value = ref(response.message)
    success.value = true
    msgUsers.value = 'success'
    closeModal()
    getUsers()
  }
}

const destroy = async (id) => {
  const response = reactive(await appimmoService.destroy('users/' + id))
  if (response.data.success === false) {
    errorMsg.value = ref(response.data.data.name[0])
    responseMsg.value = ref(response.data.message)
    success.value = false
    msgType.value = 'error'
  } else {
    responseMsg.value = ref(response.data.message)
    success.value = true
    msgType.value = 'success'
    closeModal()
  }
  const toast = {message: responseMsg.value, msgType: msgType.value, time: Date.now(), show: true}
  toastStore.newToast(toast)
}

const getUsers = async () => {
  const response = await appimmoService.get('users')

  users.value = response.data.users
}

const getRoles = async () => {
  const response = await appimmoService.get('roles')

  roles.value = response.data.roles
}

onMounted(() => {
  getUsers()
  getRoles()
})

</script>

<template>

  <Toast/>

  <div class="relative overflow-x-auto shadow-md sm:rounded-lg">
    <div class="p-4 flex flex-col justify-between md:flex-row flex-wrap">
      <button @click="create"  type="button"
              :class="themeStore.dark ? 'bg-blue-600 hover:bg-blue-700 focus:ring-blue-800' : 'bg-blue-700 hover:bg-blue-800 focus:ring-blue-300'"
              class="text-white flex self-end md:order-last focus:ring-4 font-medium rounded-lg text-sm px-5 py-2.5 mr-2 mb-2 focus:outline-none">
        Ajouter
      </button>
      <label for="table-search" class="sr-only">Search</label>
      <div class="relative mt-1">
        <div class="absolute inset-y-0 left-0 flex items-center pl-3 pointer-events-none">
          <svg :class="themeStore.dark ? 'text-gray-400' : 'text-gray-500'" class="w-5 h-5" fill="currentColor" viewBox="0 0 20 20" xmlns="http://www.w3.org/2000/svg"><path fill-rule="evenodd" d="M8 4a4 4 0 100 8 4 4 0 000-8zM2 8a6 6 0 1110.89 3.476l4.817 4.817a1 1 0 01-1.414 1.414l-4.816-4.816A6 6 0 012 8z" clip-rule="evenodd"></path></svg>
        </div>
        <input v-model="search" @keyup="filter" type="text" id="table-search" :class="themeStore.dark ? 'bg-gray-700 border-gray-600 placeholder-gray-400 text-white focus:ring-blue-500 focus:border-blue-500' : 'bg-gray-50 border border-gray-300 text-gray-900 focus:ring-blue-500 focus:border-blue-500'" class="text-sm rounded-lg block w-full md:w-80 pl-10 p-2.5" placeholder="Search for items">
      </div>
    </div>
    <table :class="themeStore.dark ? 'text-gray-400' : 'text-gray-500'" class="w-full text-sm text-left">
      <thead :class="themeStore.dark ? 'bg-gray-700 text-gray-400' : 'text-gray-700 bg-gray-50'" class="text-center text-xs uppercase">
      <tr>
        <th scope="col" class="px-6 py-3">
          Utilisateur
        </th>
        <th scope="col" class="px-6 py-3">
          Rôle
        </th>
        <th scope="col" class="px-6 py-3">
          Actions
        </th>
      </tr>
      </thead>
      <tbody>
      {{users}}
      <tr v-if="users != null" v-for="(user, index) in users" :class="themeStore.dark ? 'bg-gray-800 border-gray-700 hover:bg-gray-600' : 'bg-white hover:bg-gray-50'" class="border-b">
        <th @click="show(index)" scope="row" :class="themeStore.dark ? 'text-white' : 'text-gray-900'" class="px-6 py-4 font-medium whitespace-nowrap">
          {{ user.username }}
        </th>
        <th @click="show(index)" scope="row" :class="themeStore.dark ? 'text-white' : 'text-gray-900'" class="px-6 py-4 font-medium whitespace-nowrap">
          {{ user.role }}
        </th>
        <td class="px-6 py-2 flex justify-center gap-6 items-center h-full">
          <!-- Modal toggle -->
          <button @click="edit(user.id)"
                  :class="themeStore.dark ? 'bg-blue-600 hover:bg-blue-700 focus:ring-blue-800' : 'bg-blue-700 hover:bg-blue-800'"
                  class="flex flex-row items-center text-white block focus:ring-4 focus:outline-none focus:ring-blue-300 font-medium rounded-lg text-sm px-5 py-2.5 text-center" type="button" data-modal-toggle="defaultModal">
            <span>
              <svg xmlns="http://www.w3.org/2000/svg" class="h-5 w-5" viewBox="0 0 20 20" fill="currentColor">
                <path d="M17.414 2.586a2 2 0 00-2.828 0L7 10.172V13h2.828l7.586-7.586a2 2 0 000-2.828z" />
                <path fill-rule="evenodd" d="M2 6a2 2 0 012-2h4a1 1 0 010 2H4v10h10v-4a1 1 0 112 0v4a2 2 0 01-2 2H4a2 2 0 01-2-2V6z" clip-rule="evenodd" />
              </svg>
            </span>
            <span>Éditer</span>
          </button>
          <button @click="destroy(user.id)" data-modal-toggle="defaultModal" type="button"
                  :class="themeStore.dark ? 'bg-red-600 hover:bg-red-700 focus:ring-red-800' : 'bg-red-700 hover:bg-red-800 focus:ring-red-300'"
                  class="text-white focus:ring-4 focus:outline-none font-medium rounded-lg text-sm px-5 py-2.5 text-center">
            Supprimer
          </button>
        </td>
      </tr>
      </tbody>
    </table>
  </div>

  <!-- Main modal -->
  <div v-if="modalOpened" id="defaultModal" tabindex="-1" aria-hidden="true" class="overflow-y-auto overflow-x-hidden fixed top-0 right-0 left-0 z-40 w-full md:inset-0 h-modal md:h-full">
    <div class="mx-auto relative p-4 w-full max-w-2xl h-full md:h-auto">
      <!-- Modal content -->
      <div :class="themeStore.dark ? 'bg-gray-700' : 'bg-white'" class="relative rounded-lg shadow">
        <!-- Modal header -->
        <div :class="themeStore.dark ? 'border-gray-600' : ''" class="flex justify-between items-start p-4 rounded-t border-b">
          <h3 :class="themeStore.dark ? 'text-white' : 'text-gray-900'" class="text-xl font-semibold">
            {{ modalTitle }}
          </h3>
          <button @click="closeModal"  type="button" :class="themeStore.dark ? 'text-gray-400 hover:bg-gray-600 hover:text-white' : 'text-gray-400 hover:bg-gray-200 hover:text-gray-900'" class="bg-transparent rounded-lg text-sm p-1.5 ml-auto inline-flex items-center" data-modal-toggle="defaultModal">
            <svg class="w-5 h-5" fill="currentColor" viewBox="0 0 20 20" xmlns="http://www.w3.org/2000/svg"><path fill-rule="evenodd" d="M4.293 4.293a1 1 0 011.414 0L10 8.586l4.293-4.293a1 1 0 111.414 1.414L11.414 10l4.293 4.293a1 1 0 01-1.414 1.414L10 11.414l-4.293 4.293a1 1 0 01-1.414-1.414L8.586 10 4.293 5.707a1 1 0 010-1.414z" clip-rule="evenodd"></path></svg>
          </button>
        </div>
        <!-- Modal body -->
        <div class="p-6 space-y-6">
          <div class="mb-6">
            <label :class="themeStore.dark ? 'text-gray-300' : 'text-gray-900'" class="block mb-2 text-sm font-medium  ">Utilisateur</label>

            <input v-if="isShowing" v-model="currentUser.username" type="text" id="showing_type_name"
                   :class="
                   themeStore.dark ? 'bg-gray-700 border-gray-600 placeholder-gray-400 text-white focus:ring-blue-500 focus:border-blue-500' : 'bg-gray-50 border-gray-300 text-gray-900 focus:ring-blue-500 focus:border-blue-500',
                    (themeStore.dark && !success) ? 'bg-red-50 border-red-500 text-red-900 placeholder-red-700 focus:ring-red-500' : '',
                    (!themeStore.dark && !success) ? 'bg-red-50 border-red-500 text-red-900 placeholder-red-700 focus:ring-red-500' : ''"
                   class=" border  text-sm rounded-lg  block w-full p-2.5" disabled>
            <input v-else-if="isEditing" v-model="currentUser.username" type="text" id="editing_user_name"
                   :class="
                   themeStore.dark ? 'bg-gray-700 border-gray-600 placeholder-gray-400 text-white focus:ring-blue-500 focus:border-blue-500' : 'bg-gray-50 border-gray-300 text-gray-900 focus:ring-blue-500 focus:border-blue-500',
                    (themeStore.dark && !success) ? 'bg-red-50 border-red-500 text-red-900 placeholder-red-700 focus:ring-red-500' : '',
                    (!themeStore.dark && !success) ? 'bg-red-50 border-red-500 text-red-900 placeholder-red-700 focus:ring-red-500' : ''"
                   class="border text-sm rounded-lg  block w-full p-2.5" required>
            <input v-else v-model="currentUser.username" type="text" id="user_name"
                   :class="
                   themeStore.dark ? 'bg-gray-700 border-gray-600 placeholder-gray-400 text-white focus:ring-blue-500 focus:border-blue-500' : 'bg-gray-50 border-gray-300 text-gray-900 focus:ring-blue-500 focus:border-blue-500',
                    (themeStore.dark && !success) ? 'bg-red-50 border-red-500 text-red-900 placeholder-red-700 focus:ring-red-500' : '',
                    (!themeStore.dark && !success) ? 'bg-red-50 border-red-500 text-red-900 placeholder-red-700 focus:ring-red-500' : ''"
                   class=" border  text-sm rounded-lg  block w-full p-2.5" placeholder="Nouvel utilisateur" required>
            <p :class="themeStore.dark ? 'text-red-500' : 'text-red-600'" class="mt-2 text-sm"><span class="font-medium">{{ errorMsg.value }}</span></p>
          </div>


          <div class="mb-6">
            <label :class="themeStore.dark ? 'text-gray-300' : 'text-gray-900'" class="block mb-2 text-sm font-medium  ">Rôle</label>

            <select v-model="currentUser.role"
                    :class="themeStore.dark ? 'bg-gray-700 border-gray-600 placeholder-gray-400 text-white focus:ring-blue-500 focus:border-blue-500' : 'border-gray-300 bg-gray-50 text-gray-900 focus:ring-blue-500 focus:border-blue-500'"
                    class="border text-sm rounded-lg block w-full p-2.5">
<!--              <option v-for="role in roles" v-if="currentUser.role === role.name" :value="role.id" selected>{{role.name}}</option>-->
              <option v-for="role in roles" :value="role.id">{{role.name}}</option>
            </select>
          </div>

        </div>
        <!-- Modal footer -->
        <div :class="themeStore.dark ? 'border-gray-600' : 'border-gray-200'" class="flex items-center p-6 space-x-2 rounded-b border-t">
          <button v-if="isShowing" @click="edit(currentUser.id)" data-modal-toggle="defaultModal" type="button"
                  :class="themeStore.dark ? 'bg-yellow-600 hover:bg-yellow-700 focus:ring-yellow-800' : 'bg-yellow-700 hover:bg-yellow-800 focus:ring-yellow-300'"
                  class="text-white focus:ring-4 focus:outline-none font-medium rounded-lg text-sm px-5 py-2.5 text-center">
            Modifier
          </button>
          <button v-if="isShowing" @click="destroy(currentUser.id, currentUser.name)" data-modal-toggle="defaultModal" type="button"
                  :class="themeStore.dark ? 'bg-red-600 hover:bg-red-700 focus:ring-red-800' : 'bg-red-700 hover:bg-red-800 focus:ring-red-300'"
                  class="text-white focus:ring-4 focus:outline-none font-medium rounded-lg text-sm px-5 py-2.5 text-center">
            Supprimer
          </button>
          <button v-else-if="isEditing" @click="update" data-modal-toggle="defaultModal" type="button"
                  :class="themeStore.dark ? 'bg-blue-600 hover:bg-blue-700 focus:ring-blue-800' : 'bg-blue-700 hover:bg-blue-800 focus:ring-blue-300'"
                  class="text-white focus:ring-4 focus:outline-none font-medium rounded-lg text-sm px-5 py-2.5 text-center">
            Modifier
          </button>
          <button v-else @click="store" data-modal-toggle="defaultModal" type="button"
                  :class="themeStore.dark ? 'bg-blue-600 hover:bg-blue-700 focus:ring-blue-800' : 'bg-blue-700 hover:bg-blue-800 focus:ring-blue-300'"
                  class="text-white focus:ring-4 focus:outline-none font-medium rounded-lg text-sm px-5 py-2.5 text-center">
            Enregistrer
          </button>
          <button v-if="!isShowing" @click="closeModal" data-modal-toggle="defaultModal" type="button"
                  :class="themeStore.dark ? 'bg-gray-700 text-gray-300 border-gray-500 hover:text-white hover:bg-gray-600 focus:ring-gray-600' : 'text-gray-500 bg-white hover:bg-gray-100 focus:ring-blue-300 border-gray-200 hover:text-gray-900'"
                  class="focus:ring-4 focus:outline-none rounded-lg border text-sm font-medium px-5 py-2.5 focus:z-10">
            Annuler
          </button>
        </div>
      </div>
    </div>
  </div>
</template>